package generalisationIncomplete;

import static lib.IO.*;

public class WhatAreYou {

	public static void main(String[] args) {
		Vehicle[] vehicles = new Vehicle[4];
		
		println("Enter 'c' for a car and 't' for a truck and press RETURN");
		
		// Fill array with vehicles
		for (int i=0; i<vehicles.length; i++) {
			// User chooses between truck and car
			String input;
			do {
				print(i+1 + ". vehicle (c or t?):");
				input = readString().toLowerCase();
			} while (!input.equals("c") && !input.equals("t"));
			
			if (input.equals("c")) {
				// Create a car
				vehicles[i] = new Car();
				println("Created a car");
				print("Enter number of doors: ");
				((Car)vehicles[i]).setNumberOfDoors(readInt());
			}
			else {
				// Create a truck
				vehicles[i] = new Truck();
				println("Created a truck");
				print("Enter carrying capacity: ");
				((Truck)vehicles[i]).setCarryingCapacity(readInt());
			}
			
			// Enter common data
			print("Enter make: ");
			vehicles[i].setMake(readString());
			print("Enter max speed: ");
			vehicles[i].setMaxSpeed(readInt());
		}
		
		// Find the fastest truck
		println("\nWhich truck is the fastest one?");
		Truck fastest = fastestTruck(vehicles);
		
		// print attributes
		if (fastest != null) {
			println("Make: " + fastest.getMake());
			println("Max. speed: " + fastest.getMaxSpeed());
			println("Carrying capacity: " + fastest.getCarryingCapacity());
		} else 
			println("No truck found");
	}

	/**
	 * Find and return the fastest truck in the list.
	 * @param vehicles Array of vehicles
	 * @return fastest truck or <code>null</code> if there is no truck.
	 */
	private static Truck fastestTruck(Vehicle[] vehicles) {
		// TODO
	}
}
